mac80211: rework interface setup, fix race condition
[openwrt/openwrt.git] / package / kernel / mac80211 / files / lib / netifd / wireless / mac80211.sh
1 #!/bin/sh
2 . /lib/netifd/netifd-wireless.sh
3 . /lib/netifd/hostapd.sh
4 . /lib/functions/system.sh
5
6 init_wireless_driver "$@"
7
8 MP_CONFIG_INT="mesh_retry_timeout mesh_confirm_timeout mesh_holding_timeout mesh_max_peer_links
9 mesh_max_retries mesh_ttl mesh_element_ttl mesh_hwmp_max_preq_retries
10 mesh_path_refresh_time mesh_min_discovery_timeout mesh_hwmp_active_path_timeout
11 mesh_hwmp_preq_min_interval mesh_hwmp_net_diameter_traversal_time mesh_hwmp_rootmode
12 mesh_hwmp_rann_interval mesh_gate_announcements mesh_sync_offset_max_neighor
13 mesh_rssi_threshold mesh_hwmp_active_path_to_root_timeout mesh_hwmp_root_interval
14 mesh_hwmp_confirmation_interval mesh_awake_window mesh_plink_timeout"
15 MP_CONFIG_BOOL="mesh_auto_open_plinks mesh_fwding"
16 MP_CONFIG_STRING="mesh_power_mode"
17
18 wdev_tool() {
19 ucode /usr/share/hostap/wdev.uc "$@"
20 }
21
22 ubus_call() {
23 flock /var/run/hostapd.lock ubus call "$@"
24 }
25
26 drv_mac80211_init_device_config() {
27 hostapd_common_add_device_config
28
29 config_add_string path phy 'macaddr:macaddr'
30 config_add_string tx_burst
31 config_add_string distance
32 config_add_int beacon_int chanbw frag rts
33 config_add_int rxantenna txantenna txpower min_tx_power
34 config_add_int num_global_macaddr multiple_bssid
35 config_add_boolean noscan ht_coex acs_exclude_dfs background_radar
36 config_add_array ht_capab
37 config_add_array channels
38 config_add_array scan_list
39 config_add_boolean \
40 rxldpc \
41 short_gi_80 \
42 short_gi_160 \
43 tx_stbc_2by1 \
44 su_beamformer \
45 su_beamformee \
46 mu_beamformer \
47 mu_beamformee \
48 he_su_beamformer \
49 he_su_beamformee \
50 he_mu_beamformer \
51 vht_txop_ps \
52 htc_vht \
53 rx_antenna_pattern \
54 tx_antenna_pattern \
55 he_spr_sr_control \
56 he_spr_psr_enabled \
57 he_bss_color_enabled \
58 he_twt_required
59 config_add_int \
60 beamformer_antennas \
61 beamformee_antennas \
62 vht_max_a_mpdu_len_exp \
63 vht_max_mpdu \
64 vht_link_adapt \
65 vht160 \
66 rx_stbc \
67 tx_stbc \
68 he_bss_color \
69 he_spr_non_srg_obss_pd_max_offset
70 config_add_boolean \
71 ldpc \
72 greenfield \
73 short_gi_20 \
74 short_gi_40 \
75 max_amsdu \
76 dsss_cck_40
77 }
78
79 drv_mac80211_init_iface_config() {
80 hostapd_common_add_bss_config
81
82 config_add_string 'macaddr:macaddr' ifname
83
84 config_add_boolean wds powersave enable
85 config_add_string wds_bridge
86 config_add_int maxassoc
87 config_add_int max_listen_int
88 config_add_int dtim_period
89 config_add_int start_disabled
90
91 # mesh
92 config_add_string mesh_id
93 config_add_int $MP_CONFIG_INT
94 config_add_boolean $MP_CONFIG_BOOL
95 config_add_string $MP_CONFIG_STRING
96 }
97
98 mac80211_add_capabilities() {
99 local __var="$1"; shift
100 local __mask="$1"; shift
101 local __out= oifs
102
103 oifs="$IFS"
104 IFS=:
105 for capab in "$@"; do
106 set -- $capab
107
108 [ "$(($4))" -gt 0 ] || continue
109 [ "$(($__mask & $2))" -eq "$((${3:-$2}))" ] || continue
110 __out="$__out[$1]"
111 done
112 IFS="$oifs"
113
114 export -n -- "$__var=$__out"
115 }
116
117 mac80211_add_he_capabilities() {
118 local __out= oifs
119
120 oifs="$IFS"
121 IFS=:
122 for capab in "$@"; do
123 set -- $capab
124 [ "$(($4))" -gt 0 ] || continue
125 [ "$(((0x$2) & $3))" -gt 0 ] || {
126 eval "$1=0"
127 continue
128 }
129 append base_cfg "$1=1" "$N"
130 done
131 IFS="$oifs"
132 }
133
134 mac80211_hostapd_setup_base() {
135 local phy="$1"
136
137 json_select config
138
139 [ "$auto_channel" -gt 0 ] && channel=acs_survey
140
141 [ "$auto_channel" -gt 0 ] && json_get_vars acs_exclude_dfs
142 [ -n "$acs_exclude_dfs" ] && [ "$acs_exclude_dfs" -gt 0 ] &&
143 append base_cfg "acs_exclude_dfs=1" "$N"
144
145 json_get_vars noscan ht_coex min_tx_power:0 tx_burst
146 json_get_values ht_capab_list ht_capab
147 json_get_values channel_list channels
148
149 [ "$auto_channel" = 0 ] && [ -z "$channel_list" ] && \
150 channel_list="$channel"
151
152 [ "$min_tx_power" -gt 0 ] && append base_cfg "min_tx_power=$min_tx_power" "$N"
153
154 set_default noscan 0
155
156 [ "$noscan" -gt 0 ] && hostapd_noscan=1
157 [ "$tx_burst" = 0 ] && tx_burst=
158
159 chan_ofs=0
160 [ "$band" = "6g" ] && chan_ofs=1
161
162 ieee80211n=1
163 ht_capab=
164 case "$htmode" in
165 VHT20|HT20|HE20) ;;
166 HT40*|VHT40|VHT80|VHT160|HE40|HE80|HE160)
167 case "$hwmode" in
168 a)
169 case "$(( (($channel / 4) + $chan_ofs) % 2 ))" in
170 1) ht_capab="[HT40+]";;
171 0) ht_capab="[HT40-]";;
172 esac
173 ;;
174 *)
175 case "$htmode" in
176 HT40+) ht_capab="[HT40+]";;
177 HT40-) ht_capab="[HT40-]";;
178 *)
179 if [ "$channel" -lt 7 ]; then
180 ht_capab="[HT40+]"
181 else
182 ht_capab="[HT40-]"
183 fi
184 ;;
185 esac
186 ;;
187 esac
188 [ "$auto_channel" -gt 0 ] && ht_capab="[HT40+]"
189 ;;
190 *) ieee80211n= ;;
191 esac
192
193 [ -n "$ieee80211n" ] && {
194 append base_cfg "ieee80211n=1" "$N"
195
196 set_default ht_coex 0
197 append base_cfg "ht_coex=$ht_coex" "$N"
198
199 json_get_vars \
200 ldpc:1 \
201 greenfield:0 \
202 short_gi_20:1 \
203 short_gi_40:1 \
204 tx_stbc:1 \
205 rx_stbc:3 \
206 max_amsdu:1 \
207 dsss_cck_40:1
208
209 ht_cap_mask=0
210 for cap in $(iw phy "$phy" info | grep 'Capabilities:' | cut -d: -f2); do
211 ht_cap_mask="$(($ht_cap_mask | $cap))"
212 done
213
214 cap_rx_stbc=$((($ht_cap_mask >> 8) & 3))
215 [ "$rx_stbc" -lt "$cap_rx_stbc" ] && cap_rx_stbc="$rx_stbc"
216 ht_cap_mask="$(( ($ht_cap_mask & ~(0x300)) | ($cap_rx_stbc << 8) ))"
217
218 mac80211_add_capabilities ht_capab_flags $ht_cap_mask \
219 LDPC:0x1::$ldpc \
220 GF:0x10::$greenfield \
221 SHORT-GI-20:0x20::$short_gi_20 \
222 SHORT-GI-40:0x40::$short_gi_40 \
223 TX-STBC:0x80::$tx_stbc \
224 RX-STBC1:0x300:0x100:1 \
225 RX-STBC12:0x300:0x200:1 \
226 RX-STBC123:0x300:0x300:1 \
227 MAX-AMSDU-7935:0x800::$max_amsdu \
228 DSSS_CCK-40:0x1000::$dsss_cck_40
229
230 ht_capab="$ht_capab$ht_capab_flags"
231 [ -n "$ht_capab" ] && append base_cfg "ht_capab=$ht_capab" "$N"
232 }
233
234 # 802.11ac
235 enable_ac=0
236 vht_oper_chwidth=0
237 vht_center_seg0=
238
239 idx="$channel"
240 case "$htmode" in
241 VHT20|HE20) enable_ac=1;;
242 VHT40|HE40)
243 case "$(( (($channel / 4) + $chan_ofs) % 2 ))" in
244 1) idx=$(($channel + 2));;
245 0) idx=$(($channel - 2));;
246 esac
247 enable_ac=1
248 vht_center_seg0=$idx
249 ;;
250 VHT80|HE80)
251 case "$(( (($channel / 4) + $chan_ofs) % 4 ))" in
252 1) idx=$(($channel + 6));;
253 2) idx=$(($channel + 2));;
254 3) idx=$(($channel - 2));;
255 0) idx=$(($channel - 6));;
256 esac
257 enable_ac=1
258 vht_oper_chwidth=1
259 vht_center_seg0=$idx
260 ;;
261 VHT160|HE160)
262 if [ "$band" = "6g" ]; then
263 case "$channel" in
264 1|5|9|13|17|21|25|29) idx=15;;
265 33|37|41|45|49|53|57|61) idx=47;;
266 65|69|73|77|81|85|89|93) idx=79;;
267 97|101|105|109|113|117|121|125) idx=111;;
268 129|133|137|141|145|149|153|157) idx=143;;
269 161|165|169|173|177|181|185|189) idx=175;;
270 193|197|201|205|209|213|217|221) idx=207;;
271 esac
272 else
273 case "$channel" in
274 36|40|44|48|52|56|60|64) idx=50;;
275 100|104|108|112|116|120|124|128) idx=114;;
276 esac
277 fi
278 enable_ac=1
279 vht_oper_chwidth=2
280 vht_center_seg0=$idx
281 ;;
282 esac
283 [ "$band" = "5g" ] && {
284 json_get_vars background_radar:0
285
286 [ "$background_radar" -eq 1 ] && append base_cfg "enable_background_radar=1" "$N"
287 }
288 [ "$band" = "6g" ] && {
289 op_class=
290 case "$htmode" in
291 HE20) op_class=131;;
292 HE*) op_class=$((132 + $vht_oper_chwidth))
293 esac
294 [ -n "$op_class" ] && append base_cfg "op_class=$op_class" "$N"
295 }
296 [ "$hwmode" = "a" ] || enable_ac=0
297
298 if [ "$enable_ac" != "0" ]; then
299 json_get_vars \
300 rxldpc:1 \
301 short_gi_80:1 \
302 short_gi_160:1 \
303 tx_stbc_2by1:1 \
304 su_beamformer:1 \
305 su_beamformee:1 \
306 mu_beamformer:1 \
307 mu_beamformee:1 \
308 vht_txop_ps:1 \
309 htc_vht:1 \
310 beamformee_antennas:4 \
311 beamformer_antennas:4 \
312 rx_antenna_pattern:1 \
313 tx_antenna_pattern:1 \
314 vht_max_a_mpdu_len_exp:7 \
315 vht_max_mpdu:11454 \
316 rx_stbc:4 \
317 vht_link_adapt:3 \
318 vht160:2
319
320 set_default tx_burst 2.0
321 append base_cfg "ieee80211ac=1" "$N"
322 vht_cap=0
323 for cap in $(iw phy "$phy" info | awk -F "[()]" '/VHT Capabilities/ { print $2 }'); do
324 vht_cap="$(($vht_cap | $cap))"
325 done
326
327 append base_cfg "vht_oper_chwidth=$vht_oper_chwidth" "$N"
328 append base_cfg "vht_oper_centr_freq_seg0_idx=$vht_center_seg0" "$N"
329
330 cap_rx_stbc=$((($vht_cap >> 8) & 7))
331 [ "$rx_stbc" -lt "$cap_rx_stbc" ] && cap_rx_stbc="$rx_stbc"
332 vht_cap="$(( ($vht_cap & ~(0x700)) | ($cap_rx_stbc << 8) ))"
333
334 [ "$vht_oper_chwidth" -lt 2 ] && {
335 vht160=0
336 short_gi_160=0
337 }
338
339 mac80211_add_capabilities vht_capab $vht_cap \
340 RXLDPC:0x10::$rxldpc \
341 SHORT-GI-80:0x20::$short_gi_80 \
342 SHORT-GI-160:0x40::$short_gi_160 \
343 TX-STBC-2BY1:0x80::$tx_stbc_2by1 \
344 SU-BEAMFORMER:0x800::$su_beamformer \
345 SU-BEAMFORMEE:0x1000::$su_beamformee \
346 MU-BEAMFORMER:0x80000::$mu_beamformer \
347 MU-BEAMFORMEE:0x100000::$mu_beamformee \
348 VHT-TXOP-PS:0x200000::$vht_txop_ps \
349 HTC-VHT:0x400000::$htc_vht \
350 RX-ANTENNA-PATTERN:0x10000000::$rx_antenna_pattern \
351 TX-ANTENNA-PATTERN:0x20000000::$tx_antenna_pattern \
352 RX-STBC-1:0x700:0x100:1 \
353 RX-STBC-12:0x700:0x200:1 \
354 RX-STBC-123:0x700:0x300:1 \
355 RX-STBC-1234:0x700:0x400:1 \
356
357 [ "$(($vht_cap & 0x800))" -gt 0 -a "$su_beamformer" -gt 0 ] && {
358 cap_ant="$(( ( ($vht_cap >> 16) & 3 ) + 1 ))"
359 [ "$cap_ant" -gt "$beamformer_antennas" ] && cap_ant="$beamformer_antennas"
360 [ "$cap_ant" -gt 1 ] && vht_capab="$vht_capab[SOUNDING-DIMENSION-$cap_ant]"
361 }
362
363 [ "$(($vht_cap & 0x1000))" -gt 0 -a "$su_beamformee" -gt 0 ] && {
364 cap_ant="$(( ( ($vht_cap >> 13) & 3 ) + 1 ))"
365 [ "$cap_ant" -gt "$beamformee_antennas" ] && cap_ant="$beamformee_antennas"
366 [ "$cap_ant" -gt 1 ] && vht_capab="$vht_capab[BF-ANTENNA-$cap_ant]"
367 }
368
369 # supported Channel widths
370 vht160_hw=0
371 [ "$(($vht_cap & 12))" -eq 4 -a 1 -le "$vht160" ] && \
372 vht160_hw=1
373 [ "$(($vht_cap & 12))" -eq 8 -a 2 -le "$vht160" ] && \
374 vht160_hw=2
375 [ "$vht160_hw" = 1 ] && vht_capab="$vht_capab[VHT160]"
376 [ "$vht160_hw" = 2 ] && vht_capab="$vht_capab[VHT160-80PLUS80]"
377
378 # maximum MPDU length
379 vht_max_mpdu_hw=3895
380 [ "$(($vht_cap & 3))" -ge 1 -a 7991 -le "$vht_max_mpdu" ] && \
381 vht_max_mpdu_hw=7991
382 [ "$(($vht_cap & 3))" -ge 2 -a 11454 -le "$vht_max_mpdu" ] && \
383 vht_max_mpdu_hw=11454
384 [ "$vht_max_mpdu_hw" != 3895 ] && \
385 vht_capab="$vht_capab[MAX-MPDU-$vht_max_mpdu_hw]"
386
387 # maximum A-MPDU length exponent
388 vht_max_a_mpdu_len_exp_hw=0
389 [ "$(($vht_cap & 58720256))" -ge 8388608 -a 1 -le "$vht_max_a_mpdu_len_exp" ] && \
390 vht_max_a_mpdu_len_exp_hw=1
391 [ "$(($vht_cap & 58720256))" -ge 16777216 -a 2 -le "$vht_max_a_mpdu_len_exp" ] && \
392 vht_max_a_mpdu_len_exp_hw=2
393 [ "$(($vht_cap & 58720256))" -ge 25165824 -a 3 -le "$vht_max_a_mpdu_len_exp" ] && \
394 vht_max_a_mpdu_len_exp_hw=3
395 [ "$(($vht_cap & 58720256))" -ge 33554432 -a 4 -le "$vht_max_a_mpdu_len_exp" ] && \
396 vht_max_a_mpdu_len_exp_hw=4
397 [ "$(($vht_cap & 58720256))" -ge 41943040 -a 5 -le "$vht_max_a_mpdu_len_exp" ] && \
398 vht_max_a_mpdu_len_exp_hw=5
399 [ "$(($vht_cap & 58720256))" -ge 50331648 -a 6 -le "$vht_max_a_mpdu_len_exp" ] && \
400 vht_max_a_mpdu_len_exp_hw=6
401 [ "$(($vht_cap & 58720256))" -ge 58720256 -a 7 -le "$vht_max_a_mpdu_len_exp" ] && \
402 vht_max_a_mpdu_len_exp_hw=7
403 vht_capab="$vht_capab[MAX-A-MPDU-LEN-EXP$vht_max_a_mpdu_len_exp_hw]"
404
405 # whether or not the STA supports link adaptation using VHT variant
406 vht_link_adapt_hw=0
407 [ "$(($vht_cap & 201326592))" -ge 134217728 -a 2 -le "$vht_link_adapt" ] && \
408 vht_link_adapt_hw=2
409 [ "$(($vht_cap & 201326592))" -ge 201326592 -a 3 -le "$vht_link_adapt" ] && \
410 vht_link_adapt_hw=3
411 [ "$vht_link_adapt_hw" != 0 ] && \
412 vht_capab="$vht_capab[VHT-LINK-ADAPT-$vht_link_adapt_hw]"
413
414 [ -n "$vht_capab" ] && append base_cfg "vht_capab=$vht_capab" "$N"
415 fi
416
417 # 802.11ax
418 enable_ax=0
419 case "$htmode" in
420 HE*) enable_ax=1 ;;
421 esac
422
423 if [ "$enable_ax" != "0" ]; then
424 json_get_vars \
425 he_su_beamformer:1 \
426 he_su_beamformee:1 \
427 he_mu_beamformer:1 \
428 he_twt_required:0 \
429 he_spr_sr_control:3 \
430 he_spr_psr_enabled:0 \
431 he_spr_non_srg_obss_pd_max_offset:0 \
432 he_bss_color:128 \
433 he_bss_color_enabled:1
434
435 he_phy_cap=$(iw phy "$phy" info | sed -n '/HE Iftypes: AP/,$p' | awk -F "[()]" '/HE PHY Capabilities/ { print $2 }' | head -1)
436 he_phy_cap=${he_phy_cap:2}
437 he_mac_cap=$(iw phy "$phy" info | sed -n '/HE Iftypes: AP/,$p' | awk -F "[()]" '/HE MAC Capabilities/ { print $2 }' | head -1)
438 he_mac_cap=${he_mac_cap:2}
439
440 append base_cfg "ieee80211ax=1" "$N"
441 [ "$hwmode" = "a" ] && {
442 append base_cfg "he_oper_chwidth=$vht_oper_chwidth" "$N"
443 append base_cfg "he_oper_centr_freq_seg0_idx=$vht_center_seg0" "$N"
444 }
445
446 mac80211_add_he_capabilities \
447 he_su_beamformer:${he_phy_cap:6:2}:0x80:$he_su_beamformer \
448 he_su_beamformee:${he_phy_cap:8:2}:0x1:$he_su_beamformee \
449 he_mu_beamformer:${he_phy_cap:8:2}:0x2:$he_mu_beamformer \
450 he_spr_psr_enabled:${he_phy_cap:14:2}:0x1:$he_spr_psr_enabled \
451 he_twt_required:${he_mac_cap:0:2}:0x6:$he_twt_required
452
453 if [ "$he_bss_color_enabled" -gt 0 ]; then
454 append base_cfg "he_bss_color=$he_bss_color" "$N"
455 [ "$he_spr_non_srg_obss_pd_max_offset" -gt 0 ] && { \
456 append base_cfg "he_spr_non_srg_obss_pd_max_offset=$he_spr_non_srg_obss_pd_max_offset" "$N"
457 he_spr_sr_control=$((he_spr_sr_control | (1 << 2)))
458 }
459 [ "$he_spr_psr_enabled" -gt 0 ] || he_spr_sr_control=$((he_spr_sr_control | (1 << 0)))
460 append base_cfg "he_spr_sr_control=$he_spr_sr_control" "$N"
461 else
462 append base_cfg "he_bss_color_disabled=1" "$N"
463 fi
464
465
466 append base_cfg "he_default_pe_duration=4" "$N"
467 append base_cfg "he_rts_threshold=1023" "$N"
468 append base_cfg "he_mu_edca_qos_info_param_count=0" "$N"
469 append base_cfg "he_mu_edca_qos_info_q_ack=0" "$N"
470 append base_cfg "he_mu_edca_qos_info_queue_request=0" "$N"
471 append base_cfg "he_mu_edca_qos_info_txop_request=0" "$N"
472 append base_cfg "he_mu_edca_ac_be_aifsn=8" "$N"
473 append base_cfg "he_mu_edca_ac_be_aci=0" "$N"
474 append base_cfg "he_mu_edca_ac_be_ecwmin=9" "$N"
475 append base_cfg "he_mu_edca_ac_be_ecwmax=10" "$N"
476 append base_cfg "he_mu_edca_ac_be_timer=255" "$N"
477 append base_cfg "he_mu_edca_ac_bk_aifsn=15" "$N"
478 append base_cfg "he_mu_edca_ac_bk_aci=1" "$N"
479 append base_cfg "he_mu_edca_ac_bk_ecwmin=9" "$N"
480 append base_cfg "he_mu_edca_ac_bk_ecwmax=10" "$N"
481 append base_cfg "he_mu_edca_ac_bk_timer=255" "$N"
482 append base_cfg "he_mu_edca_ac_vi_ecwmin=5" "$N"
483 append base_cfg "he_mu_edca_ac_vi_ecwmax=7" "$N"
484 append base_cfg "he_mu_edca_ac_vi_aifsn=5" "$N"
485 append base_cfg "he_mu_edca_ac_vi_aci=2" "$N"
486 append base_cfg "he_mu_edca_ac_vi_timer=255" "$N"
487 append base_cfg "he_mu_edca_ac_vo_aifsn=5" "$N"
488 append base_cfg "he_mu_edca_ac_vo_aci=3" "$N"
489 append base_cfg "he_mu_edca_ac_vo_ecwmin=5" "$N"
490 append base_cfg "he_mu_edca_ac_vo_ecwmax=7" "$N"
491 append base_cfg "he_mu_edca_ac_vo_timer=255" "$N"
492 fi
493
494 hostapd_prepare_device_config "$hostapd_conf_file" nl80211
495 cat >> "$hostapd_conf_file" <<EOF
496 ${channel:+channel=$channel}
497 ${channel_list:+chanlist=$channel_list}
498 ${hostapd_noscan:+noscan=1}
499 ${tx_burst:+tx_queue_data2_burst=$tx_burst}
500 ${multiple_bssid:+mbssid=$multiple_bssid}
501 #num_global_macaddr=$num_global_macaddr
502 $base_cfg
503
504 EOF
505 json_select ..
506 }
507
508 mac80211_hostapd_setup_bss() {
509 local phy="$1"
510 local ifname="$2"
511 local macaddr="$3"
512 local type="$4"
513
514 hostapd_cfg=
515 append hostapd_cfg "$type=$ifname" "$N"
516
517 hostapd_set_bss_options hostapd_cfg "$phy" "$vif" || return 1
518 json_get_vars wds wds_bridge dtim_period max_listen_int start_disabled
519
520 set_default wds 0
521 set_default start_disabled 0
522
523 [ "$wds" -gt 0 ] && {
524 append hostapd_cfg "wds_sta=1" "$N"
525 [ -n "$wds_bridge" ] && append hostapd_cfg "wds_bridge=$wds_bridge" "$N"
526 }
527 [ "$staidx" -gt 0 -o "$start_disabled" -eq 1 ] && append hostapd_cfg "start_disabled=1" "$N"
528
529 cat >> /var/run/hostapd-$phy.conf <<EOF
530 $hostapd_cfg
531 bssid=$macaddr
532 ${default_macaddr:+#default_macaddr}
533 ${dtim_period:+dtim_period=$dtim_period}
534 ${max_listen_int:+max_listen_interval=$max_listen_int}
535 EOF
536 }
537
538 mac80211_get_addr() {
539 local phy="$1"
540 local idx="$(($2 + 1))"
541
542 head -n $idx /sys/class/ieee80211/${phy}/addresses | tail -n1
543 }
544
545 mac80211_generate_mac() {
546 local phy="$1"
547 local id="${macidx:-0}"
548
549 wdev_tool "$phy" get_macaddr id=$id num_global=$num_global_macaddr mbssid=${multiple_bssid:-0}
550 }
551
552 get_board_phy_name() (
553 local path="$1"
554 local fallback_phy=""
555
556 __check_phy() {
557 local val="$1"
558 local key="$2"
559 local ref_path="$3"
560
561 json_select "$key"
562 json_get_values path
563 json_select ..
564
565 [ "${ref_path%+*}" = "$path" ] && fallback_phy=$key
566 [ "$ref_path" = "$path" ] || return 0
567
568 echo "$key"
569 exit
570 }
571
572 json_load_file /etc/board.json
573 json_for_each_item __check_phy wlan "$path"
574 [ -n "$fallback_phy" ] && echo "${fallback_phy}.${path##*+}"
575 )
576
577 rename_board_phy_by_path() {
578 local path="$1"
579
580 local new_phy="$(get_board_phy_name "$path")"
581 [ -z "$new_phy" -o "$new_phy" = "$phy" ] && return
582
583 iw "$phy" set name "$new_phy" && phy="$new_phy"
584 }
585
586 rename_board_phy_by_name() (
587 local phy="$1"
588 local suffix="${phy##*.}"
589 [ "$suffix" = "$phy" ] && suffix=
590
591 json_load_file /etc/board.json
592 json_select wlan
593 json_select "${phy%.*}" || return 0
594 json_get_values path
595
596 prev_phy="$(iwinfo nl80211 phyname "path=$path${suffix:++$suffix}")"
597 [ -n "$prev_phy" ] || return 0
598
599 [ "$prev_phy" = "$phy" ] && return 0
600
601 iw "$prev_phy" set name "$phy"
602 )
603
604 find_phy() {
605 [ -n "$phy" ] && {
606 rename_board_phy_by_name "$phy"
607 [ -d /sys/class/ieee80211/$phy ] && return 0
608 }
609 [ -n "$path" ] && {
610 phy="$(iwinfo nl80211 phyname "path=$path")"
611 [ -n "$phy" ] && {
612 rename_board_phy_by_path "$path"
613 return 0
614 }
615 }
616 [ -n "$macaddr" ] && {
617 for phy in $(ls /sys/class/ieee80211 2>/dev/null); do
618 grep -i -q "$macaddr" "/sys/class/ieee80211/${phy}/macaddress" && {
619 path="$(iwinfo nl80211 path "$phy")"
620 rename_board_phy_by_path "$path"
621 return 0
622 }
623 done
624 }
625 return 1
626 }
627
628 mac80211_check_ap() {
629 has_ap=1
630 }
631
632 mac80211_set_ifname() {
633 local phy="$1"
634 local prefix="$2"
635 eval "ifname=\"$phy-$prefix\${idx_$prefix:-0}\"; idx_$prefix=\$((\${idx_$prefix:-0 } + 1))"
636 }
637
638 mac80211_prepare_iw_htmode() {
639 case "$htmode" in
640 VHT20|HT20|HE20) iw_htmode=HT20;;
641 HT40*|VHT40|VHT160|HE40)
642 case "$band" in
643 2g)
644 case "$htmode" in
645 HT40+) iw_htmode="HT40+";;
646 HT40-) iw_htmode="HT40-";;
647 *)
648 if [ "$channel" -lt 7 ]; then
649 iw_htmode="HT40+"
650 else
651 iw_htmode="HT40-"
652 fi
653 ;;
654 esac
655 ;;
656 *)
657 case "$(( ($channel / 4) % 2 ))" in
658 1) iw_htmode="HT40+" ;;
659 0) iw_htmode="HT40-";;
660 esac
661 ;;
662 esac
663 [ "$auto_channel" -gt 0 ] && iw_htmode="HT40+"
664 ;;
665 VHT80|HE80)
666 iw_htmode="80MHZ"
667 ;;
668 NONE|NOHT)
669 iw_htmode="NOHT"
670 ;;
671 *) iw_htmode="" ;;
672 esac
673 }
674
675 mac80211_add_mesh_params() {
676 for var in $MP_CONFIG_INT $MP_CONFIG_BOOL $MP_CONFIG_STRING; do
677 eval "mp_val=\"\$$var\""
678 [ -n "$mp_val" ] && json_add_string "$var" "$mp_val"
679 done
680 }
681
682 mac80211_setup_adhoc() {
683 local enable=$1
684 json_get_vars bssid ssid key mcast_rate
685
686 NEWUMLIST="${NEWUMLIST}$ifname "
687
688 [ "$enable" = 0 ] && {
689 ip link set dev "$ifname" down
690 return 0
691 }
692
693 keyspec=
694 [ "$auth_type" = "wep" ] && {
695 set_default key 1
696 case "$key" in
697 [1234])
698 local idx
699 for idx in 1 2 3 4; do
700 json_get_var ikey "key$idx"
701
702 [ -n "$ikey" ] && {
703 ikey="$(($idx - 1)):$(prepare_key_wep "$ikey")"
704 [ $idx -eq $key ] && ikey="d:$ikey"
705 append keyspec "$ikey"
706 }
707 done
708 ;;
709 *)
710 append keyspec "d:0:$(prepare_key_wep "$key")"
711 ;;
712 esac
713 }
714
715 brstr=
716 for br in $basic_rate_list; do
717 wpa_supplicant_add_rate brstr "$br"
718 done
719
720 mcval=
721 [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
722
723 local prev
724 json_set_namespace wdev_uc prev
725
726 json_add_object "$ifname"
727 json_add_string mode adhoc
728 [ -n "$default_macaddr" ] || json_add_string macaddr "$macaddr"
729 json_add_string ssid "$ssid"
730 json_add_string freq "$freq"
731 json_add_string htmode "$iw_htmode"
732 [ -n "$bssid" ] && json_add_string bssid "$bssid"
733 json_add_int beacon-interval "$beacon_int"
734 [ -n "$brstr" ] && json_add_string basic-rates "$brstr"
735 [ -n "$mcval" ] && json_add_string mcast-rate "$mcval"
736 [ -n "$keyspec" ] && json_add_string keys "$keyspec"
737 json_close_object
738
739 json_set_namespace "$prev"
740 }
741
742 mac80211_setup_mesh() {
743 json_get_vars ssid mesh_id mcast_rate
744
745 mcval=
746 [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
747 [ -n "$mesh_id" ] && ssid="$mesh_id"
748
749 local prev
750 json_set_namespace wdev_uc prev
751
752 json_add_object "$ifname"
753 json_add_string mode mesh
754 [ -n "$default_macaddr" ] || json_add_string macaddr "$macaddr"
755 json_add_string ssid "$ssid"
756 json_add_string freq "$freq"
757 json_add_string htmode "$iw_htmode"
758 [ -n "$mcval" ] && json_add_string mcast-rate "$mcval"
759 json_add_int beacon-interval "$beacon_int"
760 mac80211_add_mesh_params
761
762 json_close_object
763
764 json_set_namespace "$prev"
765 }
766
767 mac80211_setup_monitor() {
768 local prev
769 json_set_namespace wdev_uc prev
770
771 json_add_object "$ifname"
772 json_add_string mode monitor
773 [ -n "$freq" ] && json_add_string freq "$freq"
774 json_add_string htmode "$iw_htmode"
775 json_close_object
776
777 json_set_namespace "$prev"
778 }
779
780 wpa_supplicant_init_config() {
781 json_set_namespace wpa_supp prev
782
783 json_init
784 json_add_array config
785
786 json_set_namespace "$prev"
787 }
788
789 wpa_supplicant_add_interface() {
790 local ifname="$1"
791 local mode="$2"
792 local prev
793
794 _wpa_supplicant_common "$ifname"
795
796 json_set_namespace wpa_supp prev
797
798 json_add_object
799 json_add_string ctrl "$_rpath"
800 json_add_string iface "$ifname"
801 json_add_string mode "$mode"
802 json_add_string config "$_config"
803 [ -n "$default_macaddr" ] || json_add_string macaddr "$macaddr"
804 [ -n "$network_bridge" ] && json_add_string bridge "$network_bridge"
805 [ -n "$wds" ] && json_add_boolean 4addr "$wds"
806 json_add_boolean powersave "$powersave"
807 [ "$mode" = "mesh" ] && mac80211_add_mesh_params
808 json_close_object
809
810 json_set_namespace "$prev"
811
812 wpa_supp_init=1
813 }
814
815 wpa_supplicant_set_config() {
816 local phy="$1"
817 local prev
818
819 json_set_namespace wpa_supp prev
820 json_close_array
821 json_add_string phy "$phy"
822 json_add_boolean defer 1
823 local data="$(json_dump)"
824
825 json_cleanup
826 json_set_namespace "$prev"
827
828 ubus -S -t 0 wait_for wpa_supplicant || {
829 [ -n "$wpa_supp_init" ] || return 0
830
831 ubus wait_for wpa_supplicant
832 }
833
834 local supplicant_res="$(ubus_call wpa_supplicant config_set "$data")"
835 ret="$?"
836 [ "$ret" != 0 -o -z "$supplicant_res" ] && wireless_setup_vif_failed WPA_SUPPLICANT_FAILED
837
838 wireless_add_process "$(jsonfilter -s "$supplicant_res" -l 1 -e @.pid)" "/usr/sbin/wpa_supplicant" 1 1
839
840 }
841
842 hostapd_set_config() {
843 [ -n "$hostapd_ctrl" ] || {
844 ubus_call hostapd config_set '{ "phy": "'"$phy"'", "config": "", "prev_config": "'"${hostapd_conf_file}.prev"'" }' > /dev/null
845 return 0;
846 }
847
848 ubus wait_for hostapd
849 local hostapd_res="$(ubus_call hostapd config_set "{ \"phy\": \"$phy\", \"config\":\"${hostapd_conf_file}\", \"prev_config\": \"${hostapd_conf_file}.prev\"}")"
850 ret="$?"
851 [ "$ret" != 0 -o -z "$hostapd_res" ] && {
852 wireless_setup_failed HOSTAPD_START_FAILED
853 return
854 }
855 wireless_add_process "$(jsonfilter -s "$hostapd_res" -l 1 -e @.pid)" "/usr/sbin/hostapd" 1 1
856 }
857
858
859 wpa_supplicant_start() {
860 local phy="$1"
861
862 [ -n "$wpa_supp_init" ] || return 0
863
864 ubus_call wpa_supplicant config_set '{ "phy": "'"$phy"'" }' > /dev/null
865 }
866
867 mac80211_setup_supplicant() {
868 local enable=$1
869 local add_sp=0
870
871 wpa_supplicant_prepare_interface "$ifname" nl80211 || return 1
872
873 if [ "$mode" = "sta" ]; then
874 wpa_supplicant_add_network "$ifname"
875 else
876 wpa_supplicant_add_network "$ifname" "$freq" "$htmode" "$hostapd_noscan"
877 fi
878
879 wpa_supplicant_add_interface "$ifname" "$mode"
880
881 return 0
882 }
883
884 mac80211_prepare_vif() {
885 json_select config
886
887 json_get_vars ifname mode ssid wds powersave macaddr enable wpa_psk_file vlan_file
888 local config_wpa_psk_file="$wpa_psk_file"
889 local config_vlan_file="$vlan_file"
890
891 [ -n "$ifname" ] || {
892 local prefix;
893
894 case "$mode" in
895 ap|sta|mesh) prefix=$mode;;
896 adhoc) prefix=ibss;;
897 monitor) prefix=mon;;
898 esac
899
900 mac80211_set_ifname "$phy" "$prefix"
901 }
902
903 append active_ifnames "$ifname"
904
905 default_macaddr=
906 if [ -z "$macaddr" ]; then
907 macaddr="$(mac80211_generate_mac $phy)"
908 macidx="$(($macidx + 1))"
909 default_macaddr=1
910 elif [ "$macaddr" = 'random' ]; then
911 macaddr="$(macaddr_random)"
912 fi
913
914 local failed=
915 set_default wds 0
916 set_default powersave 0
917
918 # It is far easier to delete and create the desired interface
919 case "$mode" in
920 mesh)
921 json_get_vars $MP_CONFIG_INT $MP_CONFIG_BOOL $MP_CONFIG_STRING
922 wireless_vif_parse_encryption
923 [ -z "$htmode" ] && htmode="NOHT";
924 if wpa_supplicant -vmesh; then
925 mac80211_setup_supplicant || failed=1
926 else
927 mac80211_setup_mesh
928 fi
929 ;;
930 adhoc)
931 wireless_vif_parse_encryption
932 if [ "$wpa" -gt 0 -o "$auto_channel" -gt 0 ]; then
933 mac80211_setup_supplicant || failed=1
934 else
935 mac80211_setup_adhoc
936 fi
937 ;;
938 sta)
939 mac80211_setup_supplicant || failed=1
940 ;;
941 monitor)
942 mac80211_setup_monitor
943 ;;
944 ap)
945 # Hostapd will handle recreating the interface and
946 # subsequent virtual APs belonging to the same PHY
947 if [ -n "$hostapd_ctrl" ]; then
948 type=bss
949 else
950 type=interface
951 fi
952
953 mac80211_hostapd_setup_bss "$phy" "$ifname" "$macaddr" "$type" || return
954
955 [ -n "$hostapd_ctrl" ] || {
956 ap_ifname="${ifname}"
957 hostapd_ctrl="${hostapd_ctrl:-/var/run/hostapd/$ifname}"
958 }
959 ;;
960 esac
961
962 [ -n "$failed" ] || {
963 json_add_string _ifname "$ifname"
964 json_add_string _macaddr "$macaddr"
965 json_add_string _default_macaddr "$default_macaddr"
966 }
967
968 json_select ..
969
970 [ "$mode" == "ap" ] && {
971 [ -z "$config_wpa_psk_file" ] && hostapd_set_psk "$ifname"
972 [ -z "$config_vlan_file" ] && hostapd_set_vlan "$ifname"
973 }
974 }
975
976 mac80211_setup_vif() {
977 local name="$1"
978
979 json_select config
980 json_get_var ifname _ifname
981 json_get_vars vif_txpower
982 json_select ..
983
984 [ -z "$vif_txpower" ] || iw dev "$ifname" set txpower fixed "${vif_txpower%%.*}00"
985 [ -n "$ifname" ] && wireless_add_vif "$name" "$ifname"
986 }
987
988 get_freq() {
989 local phy="$1"
990 local channel="$2"
991 local band="$3"
992
993 case "$band" in
994 2g) band="1:";;
995 5g) band="2:";;
996 60g) band="3:";;
997 6g) band="4:";;
998 esac
999
1000 iw "$phy" info | awk -v band="$band" -v channel="[$channel]" '
1001
1002 $1 ~ /Band/ {
1003 band_match = band == $2
1004 }
1005
1006 band_match && $3 == "MHz" && $4 == channel {
1007 print $2
1008 exit
1009 }
1010 '
1011 }
1012
1013 chan_is_dfs() {
1014 local phy="$1"
1015 local chan="$2"
1016 iw "$phy" info | grep -E -m1 "(\* ${chan:-....} MHz${chan:+|\\[$chan\\]})" | grep -q "MHz.*radar detection"
1017 return $!
1018 }
1019
1020 mac80211_set_noscan() {
1021 hostapd_noscan=1
1022 }
1023
1024 drv_mac80211_cleanup() {
1025 hostapd_common_cleanup
1026 }
1027
1028 mac80211_reset_config() {
1029 local phy="$1"
1030
1031 hostapd_conf_file="/var/run/hostapd-$phy.conf"
1032 ubus_call hostapd config_set '{ "phy": "'"$phy"'", "config": "", "prev_config": "'"$hostapd_conf_file"'" }' > /dev/null
1033 ubus_call wpa_supplicant config_set '{ "phy": "'"$phy"'", "config": [] }' > /dev/null
1034 wdev_tool "$phy" set_config '{}'
1035 }
1036
1037 drv_mac80211_setup() {
1038 json_select config
1039 json_get_vars \
1040 phy macaddr path \
1041 country chanbw distance \
1042 txpower \
1043 rxantenna txantenna \
1044 frag rts beacon_int:100 htmode \
1045 num_global_macaddr:1 multiple_bssid
1046 json_get_values basic_rate_list basic_rate
1047 json_get_values scan_list scan_list
1048 json_select ..
1049
1050 json_select data && {
1051 json_get_var prev_rxantenna rxantenna
1052 json_get_var prev_txantenna txantenna
1053 json_select ..
1054 }
1055
1056 find_phy || {
1057 echo "Could not find PHY for device '$1'"
1058 wireless_set_retry 0
1059 return 1
1060 }
1061
1062 local wdev
1063 local cwdev
1064 local found
1065
1066 # convert channel to frequency
1067 [ "$auto_channel" -gt 0 ] || freq="$(get_freq "$phy" "$channel" "$band")"
1068
1069 [ -n "$country" ] && {
1070 iw reg get | grep -q "^country $country:" || {
1071 iw reg set "$country"
1072 sleep 1
1073 }
1074 }
1075
1076 hostapd_conf_file="/var/run/hostapd-$phy.conf"
1077
1078 macidx=0
1079 staidx=0
1080
1081 [ -n "$chanbw" ] && {
1082 for file in /sys/kernel/debug/ieee80211/$phy/ath9k*/chanbw /sys/kernel/debug/ieee80211/$phy/ath5k/bwmode; do
1083 [ -f "$file" ] && echo "$chanbw" > "$file"
1084 done
1085 }
1086
1087 set_default rxantenna 0xffffffff
1088 set_default txantenna 0xffffffff
1089 set_default distance 0
1090
1091 [ "$txantenna" = "all" ] && txantenna=0xffffffff
1092 [ "$rxantenna" = "all" ] && rxantenna=0xffffffff
1093
1094 [ "$rxantenna" = "$prev_rxantenna" -a "$txantenna" = "$prev_txantenna" ] || mac80211_reset_config "$phy"
1095 wireless_set_data phy="$phy" txantenna="$txantenna" rxantenna="$rxantenna"
1096
1097 iw phy "$phy" set antenna $txantenna $rxantenna >/dev/null 2>&1
1098 iw phy "$phy" set distance "$distance" >/dev/null 2>&1
1099
1100 if [ -n "$txpower" ]; then
1101 iw phy "$phy" set txpower fixed "${txpower%%.*}00"
1102 else
1103 iw phy "$phy" set txpower auto
1104 fi
1105
1106 [ -n "$frag" ] && iw phy "$phy" set frag "${frag%%.*}"
1107 [ -n "$rts" ] && iw phy "$phy" set rts "${rts%%.*}"
1108
1109 has_ap=
1110 hostapd_ctrl=
1111 ap_ifname=
1112 hostapd_noscan=
1113 wpa_supp_init=
1114 for_each_interface "ap" mac80211_check_ap
1115
1116 [ -f "$hostapd_conf_file" ] && mv "$hostapd_conf_file" "$hostapd_conf_file.prev"
1117
1118 for_each_interface "sta adhoc mesh" mac80211_set_noscan
1119 [ -n "$has_ap" ] && mac80211_hostapd_setup_base "$phy"
1120
1121 local prev
1122 json_set_namespace wdev_uc prev
1123 json_init
1124 json_set_namespace "$prev"
1125
1126 wpa_supplicant_init_config
1127
1128 mac80211_prepare_iw_htmode
1129 active_ifnames=
1130 for_each_interface "ap sta adhoc mesh monitor" mac80211_prepare_vif
1131
1132 [ -x /usr/sbin/wpa_supplicant ] && wpa_supplicant_set_config "$phy"
1133 [ -x /usr/sbin/hostapd ] && hostapd_set_config "$phy"
1134
1135 [ -x /usr/sbin/wpa_supplicant ] && wpa_supplicant_start "$phy"
1136
1137 json_set_namespace wdev_uc prev
1138 wdev_tool "$phy" set_config "$(json_dump)" $active_ifnames
1139 json_set_namespace "$prev"
1140
1141 for_each_interface "ap sta adhoc mesh monitor" mac80211_setup_vif
1142 wireless_set_up
1143 }
1144
1145 _list_phy_interfaces() {
1146 local phy="$1"
1147 if [ -d "/sys/class/ieee80211/${phy}/device/net" ]; then
1148 ls "/sys/class/ieee80211/${phy}/device/net" 2>/dev/null;
1149 else
1150 ls "/sys/class/ieee80211/${phy}/device" 2>/dev/null | grep net: | sed -e 's,net:,,g'
1151 fi
1152 }
1153
1154 list_phy_interfaces() {
1155 local phy="$1"
1156
1157 for dev in $(_list_phy_interfaces "$phy"); do
1158 readlink "/sys/class/net/${dev}/phy80211" | grep -q "/${phy}\$" || continue
1159 echo "$dev"
1160 done
1161 }
1162
1163 drv_mac80211_teardown() {
1164 json_select data
1165 json_get_vars phy
1166 json_select ..
1167 [ -n "$phy" ] || {
1168 echo "Bug: PHY is undefined for device '$1'"
1169 return 1
1170 }
1171
1172 mac80211_reset_config "$phy"
1173
1174 for wdev in $(list_phy_interfaces "$phy"); do
1175 ip link set dev "$wdev" down
1176 iw dev "$wdev" del
1177 done
1178 }
1179
1180 add_driver mac80211